/**
 * 
 */
package org.processmining.models.visualcnet;

import java.awt.Graphics2D;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.AbstractDirectedGraphEdge;
import org.processmining.models.shapes.Decorated;

/**
 * @author aadrians
 * Oct 7, 2011
 *
 */
public class CNetVEdge extends AbstractDirectedGraphEdge<CNetVNode, CNetVNode> implements Decorated {

	private ICNetEdgeDecoration decorator = null;
	

	public CNetVEdge(CNetVNode source, CNetVNode target) {
		super(source, target);
		getAttributeMap().put(AttributeMap.SHOWLABEL, false);
		getAttributeMap().put(AttributeMap.EDGEEND, ArrowType.ARROWTYPE_TECHNICAL);
	}

	/**
	 * @return the decorator
	 */
	public ICNetEdgeDecoration getDecorator() {
		return decorator;
	}

	/**
	 * @param decorator the decorator to set
	 */
	public void setDecorator(ICNetEdgeDecoration decorator) {
		this.decorator = decorator;
	}



	public void decorate(Graphics2D g2d, double x, double y, double width, double height) {
		if (decorator != null){
			decorator.decorate(g2d, x, y, width, height);
		}
	}
}
