package org.processmining.plugins.dcnet;

import java.awt.Color;
import java.awt.Image;
import java.awt.Stroke;
import java.util.List;

import javax.swing.JPopupMenu;

import org.processmining.models.cnet.CNetBinding;
import org.processmining.models.cnet.CNetNode;

public interface NodeDecorator {

	public enum BorderStyle {
		NONE, PLAIN, DOUBLE
	}

	public interface ColorSegment {
		Color getColor();

		double getSize();
	}

	public interface TrafficLightSegment {
		Color getColor();

		double getSize();
	}

	String getBindingLabel(CNetBinding binding);

	Color getBindingEdgeColor(CNetBinding binding);

	float getBindingEdgeWidth(CNetBinding binding);

	Color getBindingFillColor(CNetBinding binding);

	Color getBindingStrokeColor(CNetBinding binding);

	Stroke getBindingStroke(CNetBinding binding);

	double getBindingSize(CNetBinding binding);

	BorderStyle getBindingBorderStyle(CNetBinding binding);

	Color getBindingBorderColor(CNetBinding binding);

	Stroke getBindingBorderStroke(CNetBinding binding);

	Color getNodeFillColor(CNetNode node);

	String getNodeLabel(CNetNode node);

	JPopupMenu getNodeMenu(CNetNode node);

	JPopupMenu getBindingMenu(CNetBinding binding);

	List<ColorSegment> getNodeColorSegments(CNetNode node);

	List<TrafficLightSegment> getNodeTrafficLights(CNetNode node);

	Image getNodeIcon(CNetNode node);

}